diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/post.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/post.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/post.php	2013-07-20 15:20:47.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/post.php	2013-10-22 12:22:11.000000000 -0500
***************
*** 167,174 ****
  /**
   * Retrieve attached file path based on attachment ID.
   *
!  * You can optionally send it through the 'get_attached_file' filter, but by
!  * default it will just return the file path unfiltered.
   *
   * The function works by getting the single post meta name, named
   * '_wp_attached_file' and returning it. This is a convenience function to
--- 167,175 ----
  /**
   * Retrieve attached file path based on attachment ID.
   *
!  * By default the path will go through the 'get_attached_file' filter, but
!  * passing a true to the $unfiltered argument of get_attached_file() will
!  * return the file path unfiltered.
   *
   * The function works by getting the single post meta name, named
   * '_wp_attached_file' and returning it. This is a convenience function to
***************
*** 176,186 ****
   * attached filename through a filter.
   *
   * @since 2.0.0
-  * @uses apply_filters() Calls 'get_attached_file' on file path and attachment ID.
   *
   * @param int $attachment_id Attachment ID.
   * @param bool $unfiltered Whether to apply filters.
!  * @return string|bool The file path to the attached file, or false if the attachment does not exist.
   */
  function get_attached_file( $attachment_id, $unfiltered = false ) {
  	$file = get_post_meta( $attachment_id, '_wp_attached_file', true );
--- 177,186 ----
   * attached filename through a filter.
   *
   * @since 2.0.0
   *
   * @param int $attachment_id Attachment ID.
   * @param bool $unfiltered Whether to apply filters.
!  * @return string|bool The file path to where the attached file should be, false otherwise.
   */
  function get_attached_file( $attachment_id, $unfiltered = false ) {
  	$file = get_post_meta( $attachment_id, '_wp_attached_file', true );
***************
*** 310,318 ****
  
  	$children = get_posts( $r );
  
! 	if ( !$children )
  		return $kids;
  
  	update_post_cache($children);
  
  	foreach ( $children as $key => $child )
--- 310,321 ----
  
  	$children = get_posts( $r );
  
! 	if ( ! $children )
  		return $kids;
  
+ 	if ( ! empty( $r['fields'] ) )
+ 		return $children;
+ 
  	update_post_cache($children);
  
  	foreach ( $children as $key => $child )
***************
*** 375,381 ****
   * $post, must be given as a variable, since it is passed by reference.
   *
   * @since 1.5.1
-  * @uses $wpdb
   * @link http://codex.wordpress.org/Function_Reference/get_post
   *
   * @param int|object $post Post ID or post object. Optional, default is the current post from the loop.
--- 378,383 ----
***************
*** 424,582 ****
  final class WP_Post {
  
  	/**
  	 *
  	 * @var int
  	 */
  	public $ID;
  
  	/**
  	 *
! 	 * @var int
  	 */
  	public $post_author = 0;
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $post_date = '0000-00-00 00:00:00';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $post_date_gmt = '0000-00-00 00:00:00';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $post_content = '';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $post_title = '';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $post_excerpt = '';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $post_status = 'publish';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $comment_status = 'open';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $ping_status = 'open';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $post_password = '';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $post_name = '';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $to_ping = '';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $pinged = '';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $post_modified = '0000-00-00 00:00:00';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $post_modified_gmt = '0000-00-00 00:00:00';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $post_content_filtered = '';
  
  	/**
  	 *
  	 * @var int
  	 */
  	public $post_parent = 0;
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $guid = '';
  
  	/**
  	 *
  	 * @var int
  	 */
  	public $menu_order = 0;
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $post_type = 'post';
  
  	/**
  	 *
  	 * @var string
  	 */
  	public $post_mime_type = '';
  
  	/**
  	 *
! 	 * @var int
! 	 */
! 	public $comment_count = 0;
! 
! 	/**
  	 *
  	 * @var string
  	 */
! 	public $filter;
  
  	/**
! 	 * Private variable used by post formats to cache parsed content.
  	 *
! 	 * @since 3.6.0
  	 *
! 	 * @var array
! 	 * @access private
  	 */
! 	public $format_content;
! 
  
  	public static function get_instance( $post_id ) {
  		global $wpdb;
--- 426,604 ----
  final class WP_Post {
  
  	/**
+ 	 * Post ID.
  	 *
  	 * @var int
  	 */
  	public $ID;
  
  	/**
+ 	 * ID of post author.
  	 *
! 	 * A numeric string, for compatibility reasons.
! 	 *
! 	 * @var string
  	 */
  	public $post_author = 0;
  
  	/**
+ 	 * The post's local publication time.
  	 *
  	 * @var string
  	 */
  	public $post_date = '0000-00-00 00:00:00';
  
  	/**
+ 	 * The post's GMT publication time.
  	 *
  	 * @var string
  	 */
  	public $post_date_gmt = '0000-00-00 00:00:00';
  
  	/**
+ 	 * The post's content.
  	 *
  	 * @var string
  	 */
  	public $post_content = '';
  
  	/**
+ 	 * The post's title.
  	 *
  	 * @var string
  	 */
  	public $post_title = '';
  
  	/**
+ 	 * The post's excerpt.
  	 *
  	 * @var string
  	 */
  	public $post_excerpt = '';
  
  	/**
+ 	 * The post's status.
  	 *
  	 * @var string
  	 */
  	public $post_status = 'publish';
  
  	/**
+ 	 * Whether comments are allowed.
  	 *
  	 * @var string
  	 */
  	public $comment_status = 'open';
  
  	/**
+ 	 * Whether pings are allowed.
  	 *
  	 * @var string
  	 */
  	public $ping_status = 'open';
  
  	/**
+ 	 * The post's password in plain text.
  	 *
  	 * @var string
  	 */
  	public $post_password = '';
  
  	/**
+ 	 * The post's slug.
  	 *
  	 * @var string
  	 */
  	public $post_name = '';
  
  	/**
+ 	 * URLs queued to be pinged.
  	 *
  	 * @var string
  	 */
  	public $to_ping = '';
  
  	/**
+ 	 * URLs that have been pinged.
  	 *
  	 * @var string
  	 */
  	public $pinged = '';
  
  	/**
+ 	 * The post's local modified time.
  	 *
  	 * @var string
  	 */
  	public $post_modified = '0000-00-00 00:00:00';
  
  	/**
+ 	 * The post's GMT modified time.
  	 *
  	 * @var string
  	 */
  	public $post_modified_gmt = '0000-00-00 00:00:00';
  
  	/**
+ 	 * A utility DB field for post content.
+ 	 *
  	 *
  	 * @var string
  	 */
  	public $post_content_filtered = '';
  
  	/**
+ 	 * ID of a post's parent post.
  	 *
  	 * @var int
  	 */
  	public $post_parent = 0;
  
  	/**
+ 	 * The unique identifier for a post, not necessarily a URL, used as the feed GUID.
  	 *
  	 * @var string
  	 */
  	public $guid = '';
  
  	/**
+ 	 * A field used for ordering posts.
  	 *
  	 * @var int
  	 */
  	public $menu_order = 0;
  
  	/**
+ 	 * The post's type, like post or page.
  	 *
  	 * @var string
  	 */
  	public $post_type = 'post';
  
  	/**
+ 	 * An attachment's mime type.
  	 *
  	 * @var string
  	 */
  	public $post_mime_type = '';
  
  	/**
+ 	 * Cached comment count.
  	 *
! 	 * A numeric string, for compatibility reasons.
  	 *
  	 * @var string
  	 */
! 	public $comment_count = 0;
  
  	/**
! 	 * Stores the post object's sanitization level.
  	 *
! 	 * Does not correspond to a DB field.
  	 *
! 	 * @var string
  	 */
! 	public $filter;
  
  	public static function get_instance( $post_id ) {
  		global $wpdb;
***************
*** 1082,1087 ****
--- 1104,1110 ----
   *     * Defaults to false.
   *     * While the default settings of exclude_from_search, publicly_queryable, show_ui, and show_in_nav_menus are
   *       inherited from public, each does not rely on this relationship and controls a very specific intention.
+  * - hierarchical - Whether the post type is hierarchical (e.g. page). Defaults to false.
   * - exclude_from_search - Whether to exclude posts with this post type from front end search results.
   *     * If not set, the opposite of public's current value is used.
   * - publicly_queryable - Whether queries can be performed on the front end for the post type as part of parse_request().
***************
*** 1091,1098 ****
   *     * If not set, the default is inherited from public.
   * - show_ui - Whether to generate a default UI for managing this post type in the admin.
   *     * If not set, the default is inherited from public.
-  * - show_in_nav_menus - Makes this post type available for selection in navigation menus.
-  *     * If not set, the default is inherited from public.
   * - show_in_menu - Where to show the post type in the admin menu.
   *     * If true, the post type is shown in its own top level menu.
   *     * If false, no menu is shown
--- 1114,1119 ----
***************
*** 1100,1105 ****
--- 1121,1128 ----
   *       be placed as a sub menu of that.
   *     * show_ui must be true.
   *     * If not set, the default is inherited from show_ui
+  * - show_in_nav_menus - Makes this post type available for selection in navigation menus.
+  *     * If not set, the default is inherited from public.
   * - show_in_admin_bar - Makes this post type available via the admin bar.
   *     * If not set, the default is inherited from show_in_menu
   * - menu_position - The position in the menu order the post type should appear.
***************
*** 1113,1123 ****
   *     * By default the capability_type is used as a base to construct capabilities.
   *     * You can see accepted values in {@link get_post_type_capabilities()}.
   * - map_meta_cap - Whether to use the internal default meta capability handling. Defaults to false.
-  * - hierarchical - Whether the post type is hierarchical (e.g. page). Defaults to false.
   * - supports - An alias for calling add_post_type_support() directly. Defaults to title and editor.
   *     * See {@link add_post_type_support()} for documentation.
!  * - register_meta_box_cb - Provide a callback function that will be called when setting up the
!  *     meta boxes for the edit form. Do remove_meta_box() and add_meta_box() calls in the callback.
   * - taxonomies - An array of taxonomy identifiers that will be registered for the post type.
   *     * Default is no taxonomies.
   *     * Taxonomies can be registered later with register_taxonomy() or register_taxonomy_for_object_type().
--- 1136,1145 ----
   *     * By default the capability_type is used as a base to construct capabilities.
   *     * You can see accepted values in {@link get_post_type_capabilities()}.
   * - map_meta_cap - Whether to use the internal default meta capability handling. Defaults to false.
   * - supports - An alias for calling add_post_type_support() directly. Defaults to title and editor.
   *     * See {@link add_post_type_support()} for documentation.
!  * - register_meta_box_cb - Provide a callback function that sets up the meta boxes
!  *     for the edit form. Do remove_meta_box() and add_meta_box() calls in the callback.
   * - taxonomies - An array of taxonomy identifiers that will be registered for the post type.
   *     * Default is no taxonomies.
   *     * Taxonomies can be registered later with register_taxonomy() or register_taxonomy_for_object_type().
***************
*** 1146,1182 ****
   *
   * @since 2.9.0
   * @uses $wp_post_types Inserts new post type object into the list
   *
!  * @param string $post_type Post type key, must not exceed 20 characters
   * @param array|string $args See optional args description above.
!  * @return object|WP_Error the registered post type object, or an error object
   */
  function register_post_type( $post_type, $args = array() ) {
  	global $wp_post_types, $wp_rewrite, $wp;
  
! 	if ( !is_array($wp_post_types) )
  		$wp_post_types = array();
  
  	// Args prefixed with an underscore are reserved for internal use.
  	$defaults = array(
! 		'labels' => array(), 'description' => '', 'publicly_queryable' => null, 'exclude_from_search' => null,
! 		'capability_type' => 'post', 'capabilities' => array(), 'map_meta_cap' => null,
! 		'_builtin' => false, '_edit_link' => 'post.php?post=%d', 'hierarchical' => false,
! 		'public' => false, 'rewrite' => true, 'has_archive' => false, 'query_var' => true,
! 		'supports' => array(), 'register_meta_box_cb' => null,
! 		'taxonomies' => array(), 'show_ui' => null, 'menu_position' => null, 'menu_icon' => null,
! 		'can_export' => true,
! 		'show_in_nav_menus' => null, 'show_in_menu' => null, 'show_in_admin_bar' => null,
! 		'delete_with_user' => null,
  	);
! 	$args = wp_parse_args($args, $defaults);
  	$args = (object) $args;
  
! 	$post_type = sanitize_key($post_type);
  	$args->name = $post_type;
  
  	if ( strlen( $post_type ) > 20 )
! 			return new WP_Error( 'post_type_too_long', __( 'Post types cannot exceed 20 characters in length' ) );
  
  	// If not set, default to the setting for public.
  	if ( null === $args->publicly_queryable )
--- 1168,1222 ----
   *
   * @since 2.9.0
   * @uses $wp_post_types Inserts new post type object into the list
+  * @uses $wp_rewrite Gets default feeds
+  * @uses $wp Adds query vars
   *
!  * @param string $post_type Post type key, must not exceed 20 characters.
   * @param array|string $args See optional args description above.
!  * @return object|WP_Error the registered post type object, or an error object.
   */
  function register_post_type( $post_type, $args = array() ) {
  	global $wp_post_types, $wp_rewrite, $wp;
  
! 	if ( ! is_array( $wp_post_types ) )
  		$wp_post_types = array();
  
  	// Args prefixed with an underscore are reserved for internal use.
  	$defaults = array(
! 		'labels'               => array(),
! 		'description'          => '',
! 		'public'               => false,
! 		'hierarchical'         => false,
! 		'exclude_from_search'  => null,
! 		'publicly_queryable'   => null,
! 		'show_ui'              => null,
! 		'show_in_menu'         => null,
! 		'show_in_nav_menus'    => null,
! 		'show_in_admin_bar'    => null,
! 		'menu_position'        => null,
! 		'menu_icon'            => null,
! 		'capability_type'      => 'post',
! 		'capabilities'         => array(),
! 		'map_meta_cap'         => null,
! 		'supports'             => array(),
! 		'register_meta_box_cb' => null,
! 		'taxonomies'           => array(),
! 		'has_archive'          => false,
! 		'rewrite'              => true,
! 		'query_var'            => true,
! 		'can_export'           => true,
! 		'delete_with_user'     => null,
! 		'_builtin'             => false,
! 		'_edit_link'           => 'post.php?post=%d',
  	);
! 	$args = wp_parse_args( $args, $defaults );
  	$args = (object) $args;
  
! 	$post_type = sanitize_key( $post_type );
  	$args->name = $post_type;
  
  	if ( strlen( $post_type ) > 20 )
! 		return new WP_Error( 'post_type_too_long', __( 'Post types cannot exceed 20 characters in length' ) );
  
  	// If not set, default to the setting for public.
  	if ( null === $args->publicly_queryable )
***************
*** 1194,1200 ****
  	if ( null === $args->show_in_admin_bar )
  		$args->show_in_admin_bar = true === $args->show_in_menu;
  
! 	// Whether to show this type in nav-menus.php. Defaults to the setting for public.
  	if ( null === $args->show_in_nav_menus )
  		$args->show_in_nav_menus = $args->public;
  
--- 1234,1240 ----
  	if ( null === $args->show_in_admin_bar )
  		$args->show_in_admin_bar = true === $args->show_in_menu;
  
! 	// If not set, default to the setting for public.
  	if ( null === $args->show_in_nav_menus )
  		$args->show_in_nav_menus = $args->public;
  
***************
*** 1206,1237 ****
  	if ( empty( $args->capabilities ) && null === $args->map_meta_cap && in_array( $args->capability_type, array( 'post', 'page' ) ) )
  		$args->map_meta_cap = true;
  
  	if ( null === $args->map_meta_cap )
  		$args->map_meta_cap = false;
  
  	$args->cap = get_post_type_capabilities( $args );
! 	unset($args->capabilities);
  
  	if ( is_array( $args->capability_type ) )
  		$args->capability_type = $args->capability_type[0];
  
! 	if ( ! empty($args->supports) ) {
! 		add_post_type_support($post_type, $args->supports);
! 		unset($args->supports);
  	} elseif ( false !== $args->supports ) {
  		// Add default features
! 		add_post_type_support($post_type, array('title', 'editor'));
  	}
  
! 	if ( false !== $args->query_var && !empty($wp) ) {
  		if ( true === $args->query_var )
  			$args->query_var = $post_type;
  		else
! 			$args->query_var = sanitize_title_with_dashes($args->query_var);
! 		$wp->add_query_var($args->query_var);
  	}
  
! 	if ( false !== $args->rewrite && ( is_admin() || '' != get_option('permalink_structure') ) ) {
  		if ( ! is_array( $args->rewrite ) )
  			$args->rewrite = array();
  		if ( empty( $args->rewrite['slug'] ) )
--- 1246,1278 ----
  	if ( empty( $args->capabilities ) && null === $args->map_meta_cap && in_array( $args->capability_type, array( 'post', 'page' ) ) )
  		$args->map_meta_cap = true;
  
+ 	// If not set, default to false.
  	if ( null === $args->map_meta_cap )
  		$args->map_meta_cap = false;
  
  	$args->cap = get_post_type_capabilities( $args );
! 	unset( $args->capabilities );
  
  	if ( is_array( $args->capability_type ) )
  		$args->capability_type = $args->capability_type[0];
  
! 	if ( ! empty( $args->supports ) ) {
! 		add_post_type_support( $post_type, $args->supports );
! 		unset( $args->supports );
  	} elseif ( false !== $args->supports ) {
  		// Add default features
! 		add_post_type_support( $post_type, array( 'title', 'editor' ) );
  	}
  
! 	if ( false !== $args->query_var && ! empty( $wp ) ) {
  		if ( true === $args->query_var )
  			$args->query_var = $post_type;
  		else
! 			$args->query_var = sanitize_title_with_dashes( $args->query_var );
! 		$wp->add_query_var( $args->query_var );
  	}
  
! 	if ( false !== $args->rewrite && ( is_admin() || '' != get_option( 'permalink_structure' ) ) ) {
  		if ( ! is_array( $args->rewrite ) )
  			$args->rewrite = array();
  		if ( empty( $args->rewrite['slug'] ) )
***************
*** 1250,1258 ****
  		}
  
  		if ( $args->hierarchical )
! 			add_rewrite_tag("%$post_type%", '(.+?)', $args->query_var ? "{$args->query_var}=" : "post_type=$post_type&name=");
  		else
! 			add_rewrite_tag("%$post_type%", '([^/]+)', $args->query_var ? "{$args->query_var}=" : "post_type=$post_type&name=");
  
  		if ( $args->has_archive ) {
  			$archive_slug = $args->has_archive === true ? $args->rewrite['slug'] : $args->has_archive;
--- 1291,1299 ----
  		}
  
  		if ( $args->hierarchical )
! 			add_rewrite_tag( "%$post_type%", '(.+?)', $args->query_var ? "{$args->query_var}=" : "post_type=$post_type&pagename=" );
  		else
! 			add_rewrite_tag( "%$post_type%", '([^/]+)', $args->query_var ? "{$args->query_var}=" : "post_type=$post_type&name=" );
  
  		if ( $args->has_archive ) {
  			$archive_slug = $args->has_archive === true ? $args->rewrite['slug'] : $args->has_archive;
***************
*** 1271,1286 ****
  				add_rewrite_rule( "{$archive_slug}/{$wp_rewrite->pagination_base}/([0-9]{1,})/?$", "index.php?post_type=$post_type" . '&paged=$matches[1]', 'top' );
  		}
  
! 		add_permastruct( $post_type, "{$args->rewrite['slug']}/%$post_type%", $args->rewrite );
  	}
  
  	if ( $args->register_meta_box_cb )
! 		add_action('add_meta_boxes_' . $post_type, $args->register_meta_box_cb, 10, 1);
  
  	$args->labels = get_post_type_labels( $args );
  	$args->label = $args->labels->name;
  
! 	$wp_post_types[$post_type] = $args;
  
  	add_action( 'future_' . $post_type, '_future_post_hook', 5, 2 );
  
--- 1312,1329 ----
  				add_rewrite_rule( "{$archive_slug}/{$wp_rewrite->pagination_base}/([0-9]{1,})/?$", "index.php?post_type=$post_type" . '&paged=$matches[1]', 'top' );
  		}
  
! 		$permastruct_args = $args->rewrite;
! 		$permastruct_args['feed'] = $permastruct_args['feeds'];
! 		add_permastruct( $post_type, "{$args->rewrite['slug']}/%$post_type%", $permastruct_args );
  	}
  
  	if ( $args->register_meta_box_cb )
! 		add_action( 'add_meta_boxes_' . $post_type, $args->register_meta_box_cb, 10, 1 );
  
  	$args->labels = get_post_type_labels( $args );
  	$args->label = $args->labels->name;
  
! 	$wp_post_types[ $post_type ] = $args;
  
  	add_action( 'future_' . $post_type, '_future_post_hook', 5, 2 );
  
***************
*** 1429,1434 ****
--- 1472,1479 ----
   * Above, the first default value is for non-hierarchical post types (like posts) and the second one is for hierarchical post types (like pages).
   *
   * @since 3.0.0
+  * @access private
+  *
   * @param object $post_type_object
   * @return object object with all the labels as member variables
   */
***************
*** 1462,1467 ****
--- 1507,1513 ----
   * @since 3.0.0
   */
  function _get_custom_object_labels( $object, $nohier_vs_hier_defaults ) {
+ 	$object->labels = (array) $object->labels;
  
  	if ( isset( $object->label ) && empty( $object->labels['name'] ) )
  		$object->labels['name'] = $object->label;
***************
*** 1617,1623 ****
   *     'post_status' - Default is 'publish'. Post status to retrieve.
   *
   * @since 1.2.0
-  * @uses $wpdb
   * @uses WP_Query::query() See for more default arguments and information.
   * @link http://codex.wordpress.org/Template_Tags/get_posts
   *
--- 1663,1668 ----
***************
*** 1666,1677 ****
   * Post meta data is called "Custom Fields" on the Administration Screen.
   *
   * @since 1.5.0
-  * @uses $wpdb
   * @link http://codex.wordpress.org/Function_Reference/add_post_meta
   *
   * @param int $post_id Post ID.
   * @param string $meta_key Metadata name.
!  * @param mixed $meta_value Metadata value.
   * @param bool $unique Optional, default is false. Whether the same key should not be added.
   * @return int|bool Meta ID on success, false on failure.
   */
--- 1711,1721 ----
   * Post meta data is called "Custom Fields" on the Administration Screen.
   *
   * @since 1.5.0
   * @link http://codex.wordpress.org/Function_Reference/add_post_meta
   *
   * @param int $post_id Post ID.
   * @param string $meta_key Metadata name.
!  * @param mixed $meta_value Metadata value. Must be serializable if non-scalar.
   * @param bool $unique Optional, default is false. Whether the same key should not be added.
   * @return int|bool Meta ID on success, false on failure.
   */
***************
*** 1691,1702 ****
   * allows removing all metadata matching key, if needed.
   *
   * @since 1.5.0
-  * @uses $wpdb
   * @link http://codex.wordpress.org/Function_Reference/delete_post_meta
   *
   * @param int $post_id post ID
   * @param string $meta_key Metadata name.
!  * @param mixed $meta_value Optional. Metadata value.
   * @return bool True on success, false on failure.
   */
  function delete_post_meta($post_id, $meta_key, $meta_value = '') {
--- 1735,1745 ----
   * allows removing all metadata matching key, if needed.
   *
   * @since 1.5.0
   * @link http://codex.wordpress.org/Function_Reference/delete_post_meta
   *
   * @param int $post_id post ID
   * @param string $meta_key Metadata name.
!  * @param mixed $meta_value Optional. Metadata value. Must be serializable if non-scalar.
   * @return bool True on success, false on failure.
   */
  function delete_post_meta($post_id, $meta_key, $meta_value = '') {
***************
*** 1711,1717 ****
   * Retrieve post meta field for a post.
   *
   * @since 1.5.0
-  * @uses $wpdb
   * @link http://codex.wordpress.org/Function_Reference/get_post_meta
   *
   * @param int $post_id Post ID.
--- 1754,1759 ----
***************
*** 1733,1744 ****
   * If the meta field for the post does not exist, it will be added.
   *
   * @since 1.5.0
-  * @uses $wpdb
   * @link http://codex.wordpress.org/Function_Reference/update_post_meta
   *
   * @param int $post_id Post ID.
   * @param string $meta_key Metadata key.
!  * @param mixed $meta_value Metadata value.
   * @param mixed $prev_value Optional. Previous value to check before removing.
   * @return bool True on success, false on failure.
   */
--- 1775,1785 ----
   * If the meta field for the post does not exist, it will be added.
   *
   * @since 1.5.0
   * @link http://codex.wordpress.org/Function_Reference/update_post_meta
   *
   * @param int $post_id Post ID.
   * @param string $meta_key Metadata key.
!  * @param mixed $meta_value Metadata value. Must be serializable if non-scalar.
   * @param mixed $prev_value Optional. Previous value to check before removing.
   * @return bool True on success, false on failure.
   */
***************
*** 1754,1760 ****
   * Delete everything from post meta matching meta key.
   *
   * @since 2.3.0
-  * @uses $wpdb
   *
   * @param string $post_meta_key Key to search for when deleting.
   * @return bool Whether the post meta key was deleted from the database
--- 1795,1800 ----
***************
*** 2029,2035 ****
  }
  
  /**
!  * Count number of posts of a post type and is user has permissions to view.
   *
   * This function provides an efficient method of finding the amount of post's
   * type a blog has. Another method is to count the amount of items in
--- 2069,2075 ----
  }
  
  /**
!  * Count number of posts of a post type and if user has permissions to view.
   *
   * This function provides an efficient method of finding the amount of post's
   * type a blog has. Another method is to count the amount of items in
***************
*** 2039,2047 ****
   * The $perm parameter checks for 'readable' value and if the user can read
   * private posts, it will display that for the user that is signed in.
   *
-  * @since 2.5.0
   * @link http://codex.wordpress.org/Template_Tags/wp_count_posts
   *
   * @param string $type Optional. Post type to retrieve count
   * @param string $perm Optional. 'readable' or empty.
   * @return object Number of posts for each status
--- 2079,2088 ----
   * The $perm parameter checks for 'readable' value and if the user can read
   * private posts, it will display that for the user that is signed in.
   *
   * @link http://codex.wordpress.org/Template_Tags/wp_count_posts
   *
+  * @since 2.5.0
+  *
   * @param string $type Optional. Post type to retrieve count
   * @param string $perm Optional. 'readable' or empty.
   * @return object Number of posts for each status
***************
*** 2049,2057 ****
  function wp_count_posts( $type = 'post', $perm = '' ) {
  	global $wpdb;
  
  	$user = wp_get_current_user();
  
! 	$cache_key = $type;
  
  	$query = "SELECT post_status, COUNT( * ) AS num_posts FROM {$wpdb->posts} WHERE post_type = %s";
  	if ( 'readable' == $perm && is_user_logged_in() ) {
--- 2090,2101 ----
  function wp_count_posts( $type = 'post', $perm = '' ) {
  	global $wpdb;
  
+ 	if ( ! post_type_exists( $type ) )
+ 		return new stdClass;
+ 
  	$user = wp_get_current_user();
  
! 	$cache_key = 'posts-' . $type;
  
  	$query = "SELECT post_status, COUNT( * ) AS num_posts FROM {$wpdb->posts} WHERE post_type = %s";
  	if ( 'readable' == $perm && is_user_logged_in() ) {
***************
*** 2063,2085 ****
  	}
  	$query .= ' GROUP BY post_status';
  
! 	$count = wp_cache_get($cache_key, 'counts');
! 	if ( false !== $count )
! 		return $count;
! 
! 	$count = $wpdb->get_results( $wpdb->prepare( $query, $type ), ARRAY_A );
! 
! 	$stats = array();
! 	foreach ( get_post_stati() as $state )
! 		$stats[$state] = 0;
  
! 	foreach ( (array) $count as $row )
! 		$stats[$row['post_status']] = $row['num_posts'];
  
! 	$stats = (object) $stats;
! 	wp_cache_set($cache_key, $stats, 'counts');
  
! 	return $stats;
  }
  
  /**
--- 2107,2134 ----
  	}
  	$query .= ' GROUP BY post_status';
  
! 	$counts = wp_cache_get( $cache_key, 'counts' );
! 	if ( false === $counts ) {
! 		$results = (array) $wpdb->get_results( $wpdb->prepare( $query, $type ), ARRAY_A );
! 		$counts = array_fill_keys( get_post_stati(), 0 );
  
! 		foreach ( $results as $row )
! 			$counts[ $row['post_status'] ] = $row['num_posts'];
  
! 		$counts = (object) $counts;
! 		wp_cache_set( $cache_key, $counts, 'counts' );
! 	}
  
! 	/**
! 	 * Modify returned post counts by status for the current post type.
! 	 *
! 	 * @since 3.7.0
! 	 *
! 	 * @param object $counts An object containing the current post_type's post counts by status.
! 	 * @param string $type   The post type.
! 	 * @param string $perm   The permission to determine if the posts are 'readable' by the current user.
! 	 */
! 	return apply_filters( 'wp_count_posts', $counts, $type, $perm );
  }
  
  /**
***************
*** 2101,2113 ****
  	$and = wp_post_mime_type_where( $mime_type );
  	$count = $wpdb->get_results( "SELECT post_mime_type, COUNT( * ) AS num_posts FROM $wpdb->posts WHERE post_type = 'attachment' AND post_status != 'trash' $and GROUP BY post_mime_type", ARRAY_A );
  
! 	$stats = array();
  	foreach( (array) $count as $row ) {
! 		$stats[$row['post_mime_type']] = $row['num_posts'];
  	}
! 	$stats['trash'] = $wpdb->get_var( "SELECT COUNT( * ) FROM $wpdb->posts WHERE post_type = 'attachment' AND post_status = 'trash' $and");
  
! 	return (object) $stats;
  }
  
  /**
--- 2150,2170 ----
  	$and = wp_post_mime_type_where( $mime_type );
  	$count = $wpdb->get_results( "SELECT post_mime_type, COUNT( * ) AS num_posts FROM $wpdb->posts WHERE post_type = 'attachment' AND post_status != 'trash' $and GROUP BY post_mime_type", ARRAY_A );
  
! 	$counts = array();
  	foreach( (array) $count as $row ) {
! 		$counts[ $row['post_mime_type'] ] = $row['num_posts'];
  	}
! 	$counts['trash'] = $wpdb->get_var( "SELECT COUNT( * ) FROM $wpdb->posts WHERE post_type = 'attachment' AND post_status = 'trash' $and");
  
! 	/**
! 	 * Modify returned attachment counts by mime type.
! 	 *
! 	 * @since 3.7.0
! 	 *
! 	 * @param object $counts    An object containing the attachment counts by mime type.
! 	 * @param string $mime_type The mime type pattern used to filter the attachments counted.
! 	 */
! 	return apply_filters( 'wp_count_attachments', (object) $counts, $mime_type );
  }
  
  /**
***************
*** 2260,2279 ****
  		$wpdb->update( $wpdb->posts, $parent_data, $parent_where + array( 'post_type' => $post->post_type ) );
  	}
  
- 	if ( 'page' == $post->post_type) {
- 	 	// if the page is defined in option page_on_front or post_for_posts,
- 		// adjust the corresponding options
- 		if ( get_option('page_on_front') == $postid ) {
- 			update_option('show_on_front', 'posts');
- 			delete_option('page_on_front');
- 		}
- 		if ( get_option('page_for_posts') == $postid ) {
- 			delete_option('page_for_posts');
- 		}
- 	} else {
- 		unstick_post($postid);
- 	}
- 
  	// Do raw query. wp_get_post_revisions() is filtered
  	$revision_ids = $wpdb->get_col( $wpdb->prepare( "SELECT ID FROM $wpdb->posts WHERE post_parent = %d AND post_type = 'revision'", $postid ) );
  	// Use wp_delete_post (via wp_delete_post_revision) again. Ensures any meta/misplaced data gets cleaned up.
--- 2317,2322 ----
